diff --git a/sql/item_create.cc b/sql/item_create.cc
index 901dfa0..b3fbdfd 100644
--- a/sql/item_create.cc
+++ b/sql/item_create.cc
@@ -3487,12 +3487,11 @@ Create_sp_func::create_with_db(THD *thd, LEX_CSTRING *db, LEX_CSTRING *name,
   sph->add_used_routine(lex, thd, qname);
   if (pkgname.m_name.length)
     sp_handler_package_body.add_used_routine(lex, thd, &pkgname);
+  Name_resolution_context *ctx= lex->current_context_or_default();
   if (arg_count > 0)
-    func= new (thd->mem_root) Item_func_sp(thd, lex->current_context(),
-                                           qname, sph, *item_list);
+    func= new (thd->mem_root) Item_func_sp(thd, ctx, qname, sph, *item_list);
   else
-    func= new (thd->mem_root) Item_func_sp(thd, lex->current_context(),
-                                           qname, sph);
+    func= new (thd->mem_root) Item_func_sp(thd, ctx, qname, sph);
 
   lex->safe_to_cache_query= 0;
   return func;
diff --git a/sql/item_subselect.cc b/sql/item_subselect.cc
index 5a447ce..9ca44c6 100644
--- a/sql/item_subselect.cc
+++ b/sql/item_subselect.cc
@@ -115,7 +115,8 @@ void Item_subselect::init(st_select_lex *select_lex,
       do not take into account expression inside aggregate functions because
       they can access original table fields
     */
-    parsing_place= (outer_select->in_sum_expr ?
+    // QQ: shouldn't we use relink_hack() instead ?
+    parsing_place= (!outer_select || outer_select->in_sum_expr ?
                     NO_MATTER :
                     outer_select->parsing_place);
     if (unit->is_unit_op() && unit->first_select()->next_select())
@@ -239,6 +240,9 @@ bool Item_subselect::fix_fields(THD *thd_param, Item **ref)
 
   {
     SELECT_LEX *upper= unit->outer_select();
+    // QQ: shouldn't we use relink_hack() instead?
+    if (!upper)
+      upper= &thd_param->lex->builtin_select;
     if (upper->parsing_place == IN_HAVING)
       upper->subquery_in_having= 1;
     /* The subquery is an expression cache candidate */
@@ -1395,12 +1399,46 @@ bool Item_singlerow_subselect::get_date(MYSQL_TIME *ltime,ulonglong fuzzydate)
 }
 
 
+/*
+  "IN" and "EXISTS" subselect can appear in two statement types:
+
+  1. Statements that can have table columns, such as SELECT, DELETE, UPDATE
+  2. Statements that cannot have table columns, e.g:
+     RETURN ((1) IN (SELECT * FROM t1))
+     IF ((1) IN (SELECT * FROM t1))
+
+  Statements of the first type call master_select_push() in the beginning.
+  In such case everything is properly linked.
+
+  Statements of the second type do not call mastr_select_push().
+  Here we catch the second case and relink thd->lex->builtin_select and
+  select_lex to properly point to each other.
+
+  QQ: Shouldn't subselects of other type also call relink_hack()?
+  QQ: Can we do it at constructor time instead?
+*/
+static void relink_hack(THD *thd, st_select_lex *select_lex)
+{
+  if (!thd->lex->select_stack_top) // Statements of the second type
+  {
+    if (!select_lex->get_master()->get_master())
+      ((st_select_lex *) select_lex->get_master())->
+        set_master(&thd->lex->builtin_select);
+    if (!thd->lex->builtin_select.get_slave())
+      thd->lex->builtin_select.set_slave(select_lex->get_master());
+  }
+}
+
+
 Item_exists_subselect::Item_exists_subselect(THD *thd,
                                              st_select_lex *select_lex):
   Item_subselect(thd), upper_not(NULL), abort_on_null(0),
   emb_on_expr_nest(NULL), optimizer(0), exists_transformed(0)
 {
   DBUG_ENTER("Item_exists_subselect::Item_exists_subselect");
+
+  relink_hack(thd, select_lex);
+
   init(select_lex, new (thd->mem_root) select_exists_subselect(thd, this));
   max_columns= UINT_MAX;
   null_value= FALSE; //can't be NULL
@@ -1443,6 +1481,9 @@ Item_in_subselect::Item_in_subselect(THD *thd, Item * left_exp,
 {
   DBUG_ENTER("Item_in_subselect::Item_in_subselect");
   DBUG_PRINT("info", ("in_strategy: %u", (uint)in_strategy));
+
+  relink_hack(thd, select_lex);
+
   left_expr_orig= left_expr= left_exp;
   /* prepare to possible disassembling the item in convert_subq_to_sj() */
   if (left_exp->type() == Item::ROW_ITEM)
diff --git a/sql/item_sum.cc b/sql/item_sum.cc
index 2ec7e3c..a880050 100644
--- a/sql/item_sum.cc
+++ b/sql/item_sum.cc
@@ -72,6 +72,7 @@ size_t Item_sum::ram_limitation(THD *thd)
 bool Item_sum::init_sum_func_check(THD *thd)
 {
   SELECT_LEX *curr_sel= thd->lex->current_select;
+  DBUG_ASSERT(curr_sel);
   if (!curr_sel->name_visibility_map)
   {
     for (SELECT_LEX *sl= curr_sel; sl; sl= sl->context.outer_select())
diff --git a/sql/opt_subselect.cc b/sql/opt_subselect.cc
index a723980..ef6524c 100644
--- a/sql/opt_subselect.cc
+++ b/sql/opt_subselect.cc
@@ -518,6 +518,7 @@ bool is_materialization_applicable(THD *thd, Item_in_subselect *in_subs,
   if (optimizer_flag(thd, OPTIMIZER_SWITCH_MATERIALIZATION) &&      // 0
         !child_select->is_part_of_union() &&                          // 1
         parent_unit->first_select()->leaf_tables.elements &&          // 2
+        child_select->outer_select() &&
         child_select->outer_select()->leaf_tables.elements &&         // 2A
         subquery_types_allow_materialization(in_subs) &&
         (in_subs->is_top_level_item() ||                               //3
diff --git a/sql/sql_lex.cc b/sql/sql_lex.cc
index 0d39a4d..15fc876 100644
--- a/sql/sql_lex.cc
+++ b/sql/sql_lex.cc
@@ -6006,9 +6006,17 @@ bool LEX::sp_for_loop_implicit_cursor_statement(THD *thd,
   bounds->m_index->sp_lex_in_use= true;
   sphead->reset_lex(thd, bounds->m_index);
   DBUG_ASSERT(thd->lex != this);
-  if (!(item= new (thd->mem_root) Item_field(thd,
-                                             thd->lex->current_context(),
-                                             NullS, NullS, &name)))
+  /*
+    We pass NULL as Name_resolution_context here.
+    It's OK, fix_fields() will not be called for this Item_field created.
+    Item_field is only needed for LEX::sp_for_loop_cursor_declarations()
+    and is used to transfer the loop index variable name, "rec" in this example:
+      FOR rec IN (SELECT * FROM t1)
+      DO
+        SELECT rec.a, rec.b;
+      END FOR;
+  */
+  if (!(item= new (thd->mem_root) Item_field(thd, NULL, NullS, NullS, &name)))
     return true;
   bounds->m_index->set_item_and_free_list(item, NULL);
   if (thd->lex->sphead->restore_lex(thd))
@@ -6112,6 +6120,19 @@ bool LEX::sp_for_loop_intrange_declarations(THD *thd, Lex_for_loop_st *loop,
                                             const LEX_CSTRING *index,
                                             const Lex_for_loop_bounds_st &bounds)
 {
+  Item *item;
+  if ((item= bounds.m_index->get_item())->type() == Item::FIELD_ITEM)
+  {
+    // We're here is the lower bound is unknown identifier
+    my_error(ER_SP_UNDECLARED_VAR, MYF(0), item->full_name());
+    return true;
+  }
+  if ((item= bounds.m_upper_bound->get_item())->type() == Item::FIELD_ITEM)
+  {
+    // We're here is the upper bound is unknown identifier
+    my_error(ER_SP_UNDECLARED_VAR, MYF(0), item->full_name());
+    return true;
+  }
   if (!(loop->m_index=
         bounds.m_index->sp_add_for_loop_variable(thd, index,
                                                  bounds.m_index->get_item())))
@@ -6989,6 +7010,38 @@ bool LEX::add_resignal_statement(THD *thd, const sp_condition_value *v)
 }
 
 
+/*
+  Make an Item when an identifier is found in the FOR loop bounds:
+    FOR rec IN cursor
+    FOR var IN var1 .. xxx
+    FOR var IN row1.field1 .. xxx
+  When we parse the first expression after the "IN" keyword,
+  we don't know yet if it's a cursor name, or a scalar SP variable name,
+  or a field of a ROW SP variable. Here we create Item_field to remember
+  the fully qualified name. Later sp_for_loop_cursor_declarations()
+  detects how to treat this name properly.
+*/
+Item *LEX::create_item_for_loop_bound(THD *thd,
+                                      const LEX_CSTRING *a,
+                                      const LEX_CSTRING *b,
+                                      const LEX_CSTRING *c)
+{
+  /*
+    Pass NULL as the name resolution context.
+    This is OK, fix_fields() won't be called for this Item_field.
+  */
+  return new (thd->mem_root) Item_field(thd, NULL, a->str, b->str, c);
+}
+
+
+bool LEX::check_expr_allows_fields_or_error(THD *thd, const char *name) const
+{
+  if (select_stack_top > 0)
+    return false; // OK, fields are allowed
+  my_error(ER_BAD_FIELD_ERROR, MYF(0), name, thd->where);
+  return true;    // Error, fields are not allowed
+}
+
 Item *LEX::create_item_ident_nospvar(THD *thd,
                                      const LEX_CSTRING *a,
                                      const LEX_CSTRING *b)
@@ -7011,12 +7064,11 @@ Item *LEX::create_item_ident_nospvar(THD *thd,
     my_error(ER_TABLENAME_NOT_ALLOWED_HERE, MYF(0), a->str, thd->where);
     return NULL;
   }
-  if ((current_select->parsing_place != IN_HAVING) ||
-      (current_select->get_in_sum_expr() > 0))
-    return new (thd->mem_root) Item_field(thd, current_context(),
-                                          NullS, a->str, b);
-  return new (thd->mem_root) Item_ref(thd, current_context(),
-                                      NullS, a->str, b);
+
+  if (current_select->parsing_place == FOR_LOOP_BOUND)
+    return create_item_for_loop_bound(thd, &null_clex_str, a, b);
+
+  return create_item_ident_field(thd, NullS, a->str, b);
 }
 
 
@@ -7217,12 +7269,11 @@ Item *LEX::create_item_ident(THD *thd,
     my_error(ER_TABLENAME_NOT_ALLOWED_HERE, MYF(0), b->str, thd->where);
     return NULL;
   }
-  if (current_select->parsing_place != IN_HAVING ||
-      current_select->get_in_sum_expr() > 0)
-    return new (thd->mem_root) Item_field(thd, current_context(),
-                                          schema, b->str, c);
-  return new (thd->mem_root) Item_ref(thd, current_context(),
-                                      schema, b->str, c);
+
+  if (current_select->parsing_place == FOR_LOOP_BOUND)
+    return create_item_for_loop_bound(thd, &null_clex_str, b, c);
+
+  return create_item_ident_field(thd, schema, b->str, c);
 }
 
 
@@ -7298,15 +7349,19 @@ bool LEX::set_user_variable(THD *thd, const LEX_CSTRING *name, Item *val)
 }
 
 
-Item *LEX::create_item_ident_nosp(THD *thd, LEX_CSTRING *name)
+Item *LEX::create_item_ident_field(THD *thd, const char *db,
+                                   const char *table, const LEX_CSTRING *name)
 {
+  if (check_expr_allows_fields_or_error(thd, name->str))
+    return NULL;
+
   if (current_select->parsing_place != IN_HAVING ||
       current_select->get_in_sum_expr() > 0)
     return new (thd->mem_root) Item_field(thd, current_context(),
-                                          NullS, NullS, name);
+                                          db, table, name);
 
   return new (thd->mem_root) Item_ref(thd, current_context(),
-                                      NullS, NullS, name);
+                                      db, table, name);
 }
 
 
@@ -7352,6 +7407,11 @@ Item *LEX::create_item_ident_sp(THD *thd, LEX_CSTRING *name,
     if (!my_strcasecmp(system_charset_info, name->str, "SQLERRM"))
       return new (thd->mem_root) Item_func_sqlerrm(thd);
   }
+
+  if (current_select->parsing_place == FOR_LOOP_BOUND)
+    return create_item_for_loop_bound(thd, &null_clex_str, &null_clex_str,
+                                      name);
+
   return create_item_ident_nosp(thd, name);
 }
 
@@ -8538,3 +8598,29 @@ bool LEX::insert_select_hack(SELECT_LEX *sel)
 
   DBUG_RETURN(FALSE);
 }
+
+
+/*
+  Create an Item_singlerow_subselect for a query expression.
+*/
+Item *LEX::create_item_query_expression(THD *thd,
+                                        const char *tok_start,
+                                        st_select_lex_unit *unit)
+{
+  if (!expr_allows_subselect || sql_command == SQLCOM_PURGE)
+  {
+    thd->parse_error(ER_SYNTAX_ERROR, tok_start);
+    return NULL;
+  }
+
+  // Add the subtree of subquery to the current SELECT_LEX
+  SELECT_LEX *curr_sel= select_stack_head();
+  DBUG_ASSERT(current_select == curr_sel);
+  if (!curr_sel)
+    curr_sel= &builtin_select;
+  curr_sel->register_unit(unit, &curr_sel->context);
+  curr_sel->add_statistics(unit);
+
+  return new (thd->mem_root)
+    Item_singlerow_subselect(thd, unit->first_select());
+}
diff --git a/sql/sql_lex.h b/sql/sql_lex.h
index 4049ac8..ff348a8 100644
--- a/sql/sql_lex.h
+++ b/sql/sql_lex.h
@@ -606,6 +606,7 @@ class st_select_lex_node {
   }
 
   inline st_select_lex_node* get_master() { return master; }
+  inline st_select_lex_node* get_slave() { return slave; }
   void include_down(st_select_lex_node *upper);
   void add_slave(st_select_lex_node *slave_arg);
   void include_neighbour(st_select_lex_node *before);
@@ -1115,6 +1116,10 @@ class st_select_lex: public st_select_lex_node
   {
     master= (st_select_lex_node *)master_unit;
   }
+  void set_master(st_select_lex *master_arg)
+  {
+    master= master_arg;
+  }
   st_select_lex_unit* first_inner_unit() 
   { 
     return (st_select_lex_unit*) slave; 
@@ -2850,6 +2855,12 @@ struct LEX: public Query_tables_list
   bool sp_for_loop_condition(THD *thd, const Lex_for_loop_st &loop);
   bool sp_for_loop_increment(THD *thd, const Lex_for_loop_st &loop);
 
+  /*
+    Check if Item_field and Item_ref are allowed in the current statement.
+    @retval false OK (fields are allowed)
+    @retval true  ERROR (fields are not allowed). Error is raised.
+  */
+  bool check_expr_allows_fields_or_error(THD *thd, const char *name) const;
 public:
   void parse_error(uint err_number= ER_SYNTAX_ERROR);
   inline bool is_arena_for_set_stmt() {return arena_for_set_stmt != 0;}
@@ -3321,12 +3332,25 @@ struct LEX: public Query_tables_list
     DBUG_RETURN(select_lex);
   }
 
+  SELECT_LEX *current_select_or_default()
+  {
+    return current_select ? current_select : &builtin_select;
+  }
+
   bool copy_db_to(LEX_CSTRING *to);
 
   Name_resolution_context *current_context()
   {
     return context_stack.head();
   }
+  Name_resolution_context *current_context_or_default()
+  {
+    Name_resolution_context *ctx= current_context();
+    if (!ctx)
+      return &builtin_select.context;
+    return ctx;
+  }
+
   /*
     Restore the LEX and THD in case of a parse error.
   */
@@ -3493,7 +3517,12 @@ struct LEX: public Query_tables_list
   Item_splocal *create_item_for_sp_var(LEX_CSTRING *name, sp_variable *spvar,
                                        const char *start, const char *end);
 
-  Item *create_item_ident_nosp(THD *thd, LEX_CSTRING *name);
+  Item *create_item_ident_field(THD *thd, const char *db, const char *table,
+                                const LEX_CSTRING *name);
+  Item *create_item_ident_nosp(THD *thd, LEX_CSTRING *name)
+  {
+    return create_item_ident_field(thd, NullS, NullS, name);
+  }
   Item *create_item_ident_sp(THD *thd, LEX_CSTRING *name,
                              const char *start, const char *end);
   Item *create_item_ident(THD *thd, LEX_CSTRING *name,
@@ -3623,6 +3652,10 @@ struct LEX: public Query_tables_list
                           const char *start,
                           const char *end);
 
+  Item *create_item_query_expression(THD *thd,
+                                     const char *tok_start,
+                                     st_select_lex_unit *unit);
+
   Item *make_item_func_replace(THD *thd, Item *org, Item *find, Item *replace);
   Item *make_item_func_substr(THD *thd, Item *a, Item *b, Item *c);
   Item *make_item_func_substr(THD *thd, Item *a, Item *b);
@@ -3800,6 +3833,17 @@ struct LEX: public Query_tables_list
            sp_for_loop_cursor_finalize(thd, loop) :
            sp_for_loop_intrange_finalize(thd, loop);
   }
+
+  /*
+    Make an Item when an identifier is found in the FOR loop bounds:
+      FOR rec IN cursor
+      FOR rec IN var1 .. var2
+      FOR rec IN row1.field1 .. xxx
+  */
+  Item *create_item_for_loop_bound(THD *thd,
+                                   const LEX_CSTRING *a,
+                                   const LEX_CSTRING *b,
+                                   const LEX_CSTRING *c);
   /* End of FOR LOOP methods */
 
   bool add_signal_statement(THD *thd, const class sp_condition_value *value);
diff --git a/sql/sql_priv.h b/sql/sql_priv.h
index 4de8b8c..9c876c0 100644
--- a/sql/sql_priv.h
+++ b/sql/sql_priv.h
@@ -361,6 +361,7 @@ enum enum_parsing_place
   IN_PART_FUNC,
   BEFORE_OPT_LIST,
   AFTER_LIST,
+  FOR_LOOP_BOUND,
   PARSING_PLACE_SIZE /* always should be the last */
 };
 
